#ifdef VXWORKS
#include <vxWorks.h>
#else
#include "portLib.h"
#endif

/* standard librairies */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Other libs includes */
#include <t3d/t3d.h>
#include <libimages3d.h>
#include "posterLib.h"

#include "stereopixelClient.h"
#include "velodyneClient.h"

/**************************************************************
 *
 * Remplissage d'une DATA_IM3D à partir d'une Sc3DImage
 *
 **************************************************************/

void
dtm_fillIm3dFromSpix3DImage (Spix3DImage*	poster_im3d,
			     DATA_IM3D*	im3d)

{
  int		i, j;
  DATA_PT3D*	pt3d;
  Spix3DPixel*	pix3d;


  pix3d = poster_im3d->pixel;
  pt3d = im3d->points_tab;
  for (i = 0; i < poster_im3d->height; i++) {
    for (j = 0; j < poster_im3d->width; j++) {
      if (pix3d->good != 0) {
	pt3d->state = GOOD_PT3D;
	pt3d->coord_1 = pix3d->x;
	pt3d->coord_2 = pix3d->y;
	pt3d->coord_3 = pix3d->z;
      } 
      else
	pt3d->state = BAD_PT3D;
      pt3d->normales = NIL_NORMALES;
      pt3d++;
      pix3d++;
    }
  }

  /* Les flags... */
  im3d->header.points = POINTS_CALCULES;
  im3d->header.repere = REPERE_CAPTEUR;

  return ;
}

/**************************************************************
 *
 * Remplissage d'une DATA_IM3D  partir d'une velodyne3DImage
 *
 **************************************************************/

void
dtm_fillIm3dFromVyn3DImage (velodyne3DImage* velodyneData,
			    DATA_IM3D* im3d)
{
  int		i, j;
  int		nbLines;
  DATA_PT3D*	point3d; 
  velodyne3DPoint	velodynePoint3d;

  /* Copy the poster into the im3d up to the number of lines that actually
     contains data */
  for (i = 0; i < velodyneData->nbLines; i++) {
    for (j = 0; j < VELODYNE_NB_COLUMNS; j++) {
      point3d = data_im3d_pt (im3d, i, j);
      velodynePoint3d = velodyneData->points[i*VELODYNE_NB_COLUMNS+j];
      if (velodyneData->points[i*VELODYNE_NB_COLUMNS+j].status == VELODYNE_GOOD_3DPOINT) {
	point3d->state = GOOD_PT3D;
	point3d->coord_1 = velodynePoint3d.coordinates[0];
	point3d->coord_2 = velodynePoint3d.coordinates[1];
	point3d->coord_3 = velodynePoint3d.coordinates[2];
      }
      else
	point3d->state = BAD_PT3D;
    }
  }
  /* Flag the points not acquired as BAD_PT3D */
  for (i = velodyneData->nbLines; i < VELODYNE_NB_LINES; i++) {
    for (j = 0; j < VELODYNE_NB_COLUMNS; j++) {
      point3d = data_im3d_pt (im3d, i, j);
      point3d->state = BAD_PT3D;
    }
  }
  
  im3d->header.coordonnees = COORDONNEES_CARTESIENNES;
  im3d->header.capteur = CAPTEUR_LASER1;
  im3d->header.repere = REPERE_CAPTEUR;
  im3d->header.points = POINTS_CALCULES;

  return ;
}
